/*
Module : SERPORT.H
Purpose: Simple MFC class to support access to GPS receivers via serial ports
         Please note this is not a generic serial port class
Created: PJN / 28-12-1997


Copyright (c) 1997 - 2001 by PJ Naughter.  (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code. 

*/

#ifndef __SERPORT_H__
#define __SERPORT_H__


////////////////////////// Includes //////////////////////////////////////
#include <gps.h>


////////////////////////// Classes ///////////////////////////////////////

class CGpsSerialPort : public CObject
{
public:
//constructors / Destructors
  CGpsSerialPort();
  ~CGpsSerialPort();

//methods
  BOOL Open(LPCGPSDEVINFO lpDevInfo);
  void Close();
  DWORD Read(LPBYTE psBuffer, UINT nBytes) const;

protected:
  HANDLE m_hPort;
};


#endif //__SERPORT_H__