Attribute VB_Name = "GPS"
Option Explicit

Const GPS_MaxDeviceName = 257

Const GpsQualityFixNotAvailable = 0
Const GpsQualityFix = 1
Const GpsQualityDifferentialFix = 2

Const GpsParityNone = 0
Const GpsParityOdd = 1
Const GpsParityEven = 2

Const GpsStopBits1 = 0
Const GpsStopBits1Point5 = 1
Const GpsStopBits2 = 2

Type GpsDevInfo
    DeviceName As String * GPS_MaxDeviceName
    DefaultReceiver As Long
    CommPort As Integer
    CommBaudRate As Long
    CommDataBits As Integer
    CommParity As Integer
    CommStopBits As Integer
End Type

Type GPSPosition
    Northing As Long
    Latitude As Long
    Easting As Long
    Longitude As Long
    Bearing As Long
    Speed As Long
    FixYear As Integer
    FixMonth As Integer
    FixDay As Integer
    FixHour As Integer
    FixMinute As Integer
    FixSecond As Integer
    Satellites As Integer
    AntennaAltitude As Long
    QualityIndicator As Integer
End Type

Declare Function GpsShowControlPanel Lib "Gps103.dll" () As Long
Declare Function GpsCreateEntry Lib "Gps103.dll" (ByVal hWnd As Long) As Long
Declare Function GpsGetNumDevices Lib "Gps103.dll" () As Long
Declare Function GpsEnumDevices Lib "Gps103.dll" (lpGpsDevInfo As GpsDevInfo, ByVal dwRequestedDevices As Long) As Byte
Declare Function GpsDeleteEntry Lib "Gps103.dll" (ByVal lpszEntry As String) As Long
Declare Function GpsRenameEntry Lib "Gps103.dll" (ByVal lpszOldEntry As String, ByVal lpszNewEntry As String) As Byte
Declare Function GpsPropertiesDlg Lib "Gps103.dll" (ByVal hWnd As Long, ByVal lpszEntry As String) As Byte
Declare Function GpsOpen Lib "Gps103.dll" (ByVal lpszEntry As String) As Long
Declare Function GpsClose Lib "Gps103.dll" (ByVal hEntry As Long) As Byte
Declare Function GpsGetPosition Lib "Gps103.dll" (ByVal hEntry As Long, lpPosition As GPSPosition) As Byte
Declare Function GpsGetVersion Lib "Gps103.dll" () As Long
Declare Function GpsDeviceNameAlreadyExists Lib "Gps103.dll" (ByVal lpszEntry As String) As Byte
Public Declare Sub GpsShowAboutBox Lib "Gps103.dll" (ByVal hWnd As Long)
Declare Function GpsGetDevice Lib "Gps103.dll" (ByVal lpszEntry As String, lpDevInfo As GpsDevInfo) As Byte
Declare Function GpsSetDevice Lib "Gps103.dll" (ByVal lpszEntry As String, lpDevInfo As GpsDevInfo) As Byte


